cenariofrente={}
cenarioatras={}
colinas={}

function cenariofrente:add(x,y,tipo)
	cenariofrente[#cenariofrente+1]= {
		x=x,
		mapa_x=x,
		y=y,
		a=0,
		mapa_visivel=false,
		img=love.graphics.newImage("gfx/"..tipo..".png")
	}
end

function cenariofrente:draw()
	love.graphics.setColor(255,255,255,255)
	for i=1,#cenariofrente do
		cf=cenariofrente[i]
		dist=math.floor(math.abs(math.dist(jogador.x,jogador.y,cf.x,cf.y)))
		if dist<=campo_visao then
			cf.a=255
			cf.mapa_visivel=true
		else
			dif=dist-campo_visao
			cf.a=255-dif
			if cf.a<=0 then cf.a=0 end
			if cf.a>0 then
				cf.mapa_visivel=true
			end
		end
		love.graphics.setColor(cf.a,cf.a,cf.a,cf.a)
		if exibe_mapa then
			alfa=cf.a-100
			if alfa<=0 then alfa=0 end
			love.graphics.setColor(100,100,100,alfa)
		end
		love.graphics.draw(cf.img,cf.x,cf.y)
	end
end

function cenariofrente:atualiza_posicao_x()
	for i=1,#cenariofrente,1 do
		if cenariofrente[i]~=nil then
			cf=cenariofrente[i]
			if string.find(jogador.direcao,"right")~=nil then
				cf.x=cf.x-val_x_atualiza_mundo
			elseif string.find(jogador.direcao,"left")~=nil then
				cf.x=cf.x+val_x_atualiza_mundo
			end
		end
	end
end

function cenariofrente:apaga()
	for i=1,#cenariofrente do
		cenariofrente[i]=nil
	end
end


function cenarioatras:add(x,y,tipo)
	cenarioatras[#cenarioatras+1]= {
		x=x,
		y=y,
		mapa_x=x,
		a=0,
		mapa_visivel=false,
		img=love.graphics.newImage("gfx/"..tipo..".png")
	}
end

function cenarioatras:draw()
	for i=1,#cenarioatras do
		ca=cenarioatras[i]
		dist=math.floor(math.abs(math.dist(jogador.x,jogador.y,ca.x,ca.y)))
		if dist<=campo_visao then
			ca.a=255
			ca.mapa_visivel=true
		else
			dif=dist-campo_visao
			ca.a=255-dif
			if ca.a<=0 then ca.a=0 end
			if ca.a>0 then
				ca.mapa_visivel=true
			end
		end
		love.graphics.setColor(100,100,100,ca.a)
		if exibe_mapa then
			alfa=ca.a-100
			if alfa<=0 then alfa=0 end
			love.graphics.setColor(100,100,100,alfa)
		end
		love.graphics.draw(ca.img,ca.x,ca.y)
	end
end


function cenarioatras:atualiza_posicao_x()
	for i=1,#cenarioatras,1 do
		if cenarioatras[i]~=nil then
			ca=cenarioatras[i]
			if string.find(jogador.direcao,"right")~=nil then
				ca.x=ca.x-val_x_atualiza_mundo
			elseif string.find(jogador.direcao,"left")~=nil then
				ca.x=ca.x+val_x_atualiza_mundo
			end
		end
	end
end

function cenarioatras:apaga()
	for i=1,#cenarioatras do
		cenarioatras[i]=nil
	end
end


function cenarioatras:exibe_mapa()
	for i,ca in ipairs(cenarioatras) do
		if move_mapa=="left" then
			if mundo[1].mapa_x<0 then ca.mapa_x=ca.mapa_x+7 end
		elseif move_mapa=="right" then
			if mundo[#mundo].mapa_x+70>(res_x*3.32)+25 then ca.mapa_x=ca.mapa_x-7 end
		end
		alfa=0
		if ca.mapa_visivel==true then alfa=255 end
		love.graphics.setColor(255,255,255,alfa)
		love.graphics.draw(ca.img,ca.mapa_x,ca.y+300)
	end
end

function cenariofrente:exibe_mapa()
	for i,cf in ipairs(cenariofrente) do
		if move_mapa=="left" then
			if mundo[1].mapa_x<0 then cf.mapa_x=cf.mapa_x+7 end
		elseif move_mapa=="right" then
			if mundo[#mundo].mapa_x+70>(res_x*3.32)+25 then cf.mapa_x=cf.mapa_x-7 end
		end

		alfa=0
		if cf.mapa_visivel==true then alfa=255 end
		love.graphics.setColor(255,255,255,alfa)
		love.graphics.draw(cf.img,cf.mapa_x,cf.y+300)
	end
end

function colinas:add(x,y,tipo)
	colinas[#colinas+1]= {
		r=0,
		g=0,
		b=0,
		x=x,
		y=y,
		a=0,
		tipo=tipo,
		img=love.graphics.newImage("gfx/"..tipo..".png")
	}
end

function colinas:draw()
	for i,c in ipairs(colinas) do
		ty=140
		if string.find(c.tipo,"short") then ty=100 end
		dist=math.floor(math.abs(math.dist(jogador.x,jogador.y,c.x+((48*8)/2),c.y+((ty*3.5)/2))))
		if dist<=campo_visao then
			c.a=255
		else
			dif=dist-campo_visao
			c.a=255-dif
			if c.a<=0 then c.a=0 end
		end
		c.r=c.a-150
		if c.r<0 then c.r=0 end
		c.g,c.b=c.r,c.r
		love.graphics.setColor(c.r,c.g,c.b,c.a)
		if exibe_mapa then
			alfa=c.a-150
			if alfa<=0 then alfa=0 end
			c.r=c.a-150
			if c.r<0 then c.r=0 end
			c.g,c.b=c.r,c.r
			love.graphics.setColor(c.r,c.g,c.b,alfa)
		end
		love.graphics.draw(c.img,c.x,c.y,0,8,3.5)
	end
end

function colinas:atualiza_posicao_x()
	for i=1,#colinas,1 do
		if colinas[i]~=nil then
			c=colinas[i]
			if string.find(jogador.direcao,"right")~=nil then
				c.x=c.x-val_x_atualiza_mundo
			elseif string.find(jogador.direcao,"left")~=nil then
				c.x=c.x+val_x_atualiza_mundo
			end
		end
	end
end

function colinas:apaga()
	for i=1,#colinas do
		colinas[i]=nil
	end
end
