chave = {}

img_chave_verde=love.graphics.newImage("gfx/key_green_icon.png")
img_chave_azul=love.graphics.newImage("gfx/key_blue_icon.png")
img_chave_vermelha=love.graphics.newImage("gfx/key_red_icon.png")
img_chave_amarela=love.graphics.newImage("gfx/key_yellow_icon.png")

function chave:add(x,y,cor)
	self[#self+1] = {
		x=x,
		y=y,
		ini_y=y,
		cor=cor,
		img=love.graphics.newImage("gfx/key_"..cor..".png"),
		cria_efeito=false,
		seq_efeito=1,
		tempo_efeito=0,
		alfa=255,
		total_efeito=0,
		exibe=true
	}
end

function chave:draw()
	local a=0
	for i=1,#chave do
		if chave[i].exibe==true then
			c=chave[i]
			a=c.alfa
			love.graphics.setColor(255,255,255,a)
			if exibe_mapa then love.graphics.setColor(100,100,100,100) end
			love.graphics.draw(c.img,c.x,c.y)
			if math.abs(c.y-c.ini_y)<50 then c.y=c.y+1+t end
		end
	end
	love.graphics.setColor(255,255,255,255)
end

function chave:testa_colisao_jogador()
	local jx,jy,jl,ja=jogador.x,jogador.y,img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	local cl,ca=60,37
	local xg,xb,xr,xy=20,70,120,170

	for i=1,#chave do
		if chave[i].exibe==true then
			c=chave[i]
			if checa_colisao(jx,jy,jl,ja,c.x,c.y,cl,ca) and c.cria_efeito==false then
				xc,yc=0,5
				if c.cor=="green" then
					jogador.chave_verde=true
					xc=xg
				elseif c.cor=="red" then
					jogador.chave_vermelha=true
					xc=xr
				elseif c.cor=="blue" then
					jogador.chave_azul=true
					xc=xb
				elseif c.cor=="yellow" then
					jogador.chave_amarela=true
					xc=xy
				end
				c.cria_efeito=true
				c.total_efeito=40
				if math.dist(c.x,c.y,xc,xy)<501 then
					c.total_efeito=15
				elseif math.dist(c.x,c.y,xc,xy)<701 then
					c.total_efeito=20
				elseif math.dist(c.x,c.y,xc,xy)<901 then
					c.total_efeito=25
				elseif math.dist(c.x,c.y,xc,xy)<1001 then
					c.total_efeito=30
				elseif math.dist(c.x,c.y,xc,xy)<1201 then
					c.total_efeito=35
				end
			end
		end
	end
end

function chave:cria_efeito()
	local xg,xb,xr,xy=20,70,120,170

	for i=1,#chave do
		if chave[i].exibe==true then
			c=chave[i]
			if c.cria_efeito==true then
				c.alfa=c.alfa-9
				if c.alfa<0 then c.alfa=0 end
				cx=c.x
				if c.cor=="green" then
					dist_x=math.abs(cx-xg)
				elseif c.cor=="red" then
					dist_x=math.abs(cx-xr)
				elseif c.cor=="blue" then
					dist_x=math.abs(cx-xb)
				elseif c.cor=="yellow" then
					dist_x=math.abs(cx-xy)
				end
				dist_y=c.y-5
				px=dist_x/c.total_efeito
				py=dist_y/c.total_efeito
				x=c.x-(px*c.seq_efeito)
				y=c.y-(py*c.seq_efeito)
				efeito:add(x,y,"estrela_chave",c.cor)

				c.seq_efeito=c.seq_efeito+1
				c.tempo_efeito=love.timer.getMicroTime()+5
				if c.seq_efeito>=c.total_efeito then
					chave[i].exibe=false
				end
			end
		end
	end
end


function chave:atualiza_posicao_x()
	for i=1,#chave do
		if chave[i].exibe==true then
			c=chave[i]
			if string.find(jogador.direcao,"right")~=nil then
				c.x=c.x-val_x_atualiza_mundo
			elseif string.find(jogador.direcao,"left")~=nil then
				c.x=c.x+val_x_atualiza_mundo
			end
		end
	end
end

function chave:apaga()
	for i=1,#chave do
		chave[i]=nil
	end
end
