efeito = {}

img_sparkle = love.graphics.newImage("gfx/sparkle.png")

function efeito:add(x,y,tipo,var)
	self[#self+1]= {
		x=x,
		y=y,
		ini_x=x,
		ini_y=y,
		tipo=tipo,
		angulo=0,
		tamanho=0,
		frame=0,
		frame_x=0,
		frame_y=0,
		r=math.random(0,255),
		g=math.random(0,255),
		b=math.random(0,255),
		a=255,
		ini_a=a,
		tempo=love.timer.getMicroTime(),
		exibe=true,
		vel_x=0,
		vel_y=0,
		dir=var,
		img="",
		cor=""
	}
	if string.find(tipo,"estrela")~=nil then
		self[#self].img=love.graphics.newImage("gfx/estrela.png")
		self[#self].tamanho=math.random(2,5)/10
		dir=math.random(-1,1)
		if dir==0 then dir=1 end
		self[#self].vel_x=(math.random(1,3)/10)*dir
		self[#self].vel_y=-math.random(1,3)/10
		if tipo=="estrela_chave" then
			self[#self].vel_x=0
			self[#self].vel_y=0
			self[#self].tempo=love.timer.getMicroTime()-5000
		end
		if tipo=="estrela_lock" or tipo=="estrela_chave" then self[#self].cor=var end
		self[#self].angulo=math.random(0,359)
	end
	if string.find(tipo,"bubbles")~=nil then
		self[#self].vel_x=(math.random(1,2)/10)*var
		self[#self].vel_y=-math.random(1,4)/10
		self[#self].tamanho=math.random(2,6)
	end
	if string.find(tipo,"luz")~=nil then
		self[#self].tamanho=17+var
		self[#self].a=100-(var*10)
		self[#self].ini_a=100-(var*10)
	end
end

function efeito:draw()
	for i=1,#efeito do
		if efeito[i].exibe==true then
			e=efeito[i]
			if string.find(e.tipo,"estrela")~=nil then
				love.graphics.setColor(e.r,e.g,e.b,e.a)
				if e.tipo=="estrela_lock" then
					if e.cor=="green" then
						love.graphics.setColor(0,255,0,e.a)
					elseif e.cor=="blue" then
						love.graphics.setColor(0,0,255,e.a)
					elseif e.cor=="red" then
						love.graphics.setColor(255,0,0,e.a)
					elseif e.cor=="yellow" then
						love.graphics.setColor(255,255,0,e.a)
					end
				end
				love.graphics.draw(e.img,e.x,e.y,math.rad(e.angulo),1,1)
				e.angulo=e.angulo+.50
				e.x=e.x+e.vel_x
				if e.tipo~="estrela_chave" then
					e.vel_y=e.vel_y+.0025
				else
					love.graphics.setColor(255,255,255,e.a)
					if e.cor=="green" then
						love.graphics.draw(img_chave_verde,e.x,e.y,0,.4,.4)
					elseif c.cor=="red" then
						love.graphics.draw(img_chave_vermelha,e.x,e.y,0,.4,.4)
					elseif c.cor=="blue" then
						love.graphics.draw(img_chave_azul,e.x,e.y,0,.4,.4)
					elseif c.cor=="yellow" then
						love.graphics.draw(img_chave_amarela,e.x,e.y,0,.4,.4)
					end
				end
				e.y=e.y+e.vel_y
				if e.a>0 then
					e.a=e.a-1
					if e.tipo=="estrela_chave" then
						e.a=e.a-1
						if e.a<0 then e.a=0 end
					end
				else
					e.a=0
					e.exibe=false
					e=nil
				end
			elseif string.find(e.tipo,"sparkle")~=nil then
				local quad = love.graphics.newQuad(e.frame_x,e.frame_y,32,32,img_sparkle:getWidth(),img_sparkle:getHeight())
				love.graphics.setColor(255,255,255,255)
				love.graphics.drawq(img_sparkle,quad,e.x,e.y)
				if love.timer.getMicroTime()>=e.tempo+.05 then
					e.tempo=love.timer.getMicroTime()
					e.frame=e.frame+1
					if e.frame>=15 then
						e.exibe=false
						e=nil
					else
						e.frame_x=e.frame_x+32
						if math.fmod(e.frame,4)==0 then
							e.frame_x=0
							--if e.tipo=="sparkle_ballon" then e.frame_x=128 end
							e.frame_y=e.frame_y+32
						end
					end
				end
			elseif e.tipo=="bubbles" then
				love.graphics.setColor(128,255,255,e.a)
				love.graphics.circle("fill",e.x,e.y,e.tamanho,10)
				e.x=e.x+e.vel_x
				e.vel_y=e.vel_y+.0050
				e.y=e.y+e.vel_y
				if e.a>0 then
					e.a=e.a-1.5
				else
					e.a=0
					e.exibe=false
					e=nil
				end
			elseif string.find(e.tipo,"luz")~=nil then
				love.graphics.setColor(200,200,200,e.a)
				love.graphics.circle("fill",e.x,e.y,e.tamanho,100)
				e.a=e.a-0.5
				if e.a<=0 then
					e.a=e.ini_a
				end
			end
		end
	end

	return true
end

function efeito:atualiza_posicao_x()
	for i=1,#efeito,1 do
		if efeito[i]~=nil then
			e=efeito[i]
			if e.tipo~="estrela_chave" then
				if string.find(jogador.direcao,"right")~=nil then
					e.x=e.x-val_x_atualiza_mundo
				elseif string.find(jogador.direcao,"left")~=nil then
					e.x=e.x+val_x_atualiza_mundo
				end
			end
		end
	end
end

function efeito:apaga(tipo)
	for i=1,#efeito do
		if tipo~="" then
			if efeito[i].tipo==tipo then
				efeito[i].exibe=false
			end
		else
			efeito[i]=nil
		end
	end
end

