moeda = {}

function moeda:add(x,y,valor,vx,vy,dir)
	self[#self+1] = {
		x=x,
		y=y,
		vel_x=0,
		vel_y=0,
		dir="",
		img="",
		exibe=true,
		colisao=false,
		tempo=love.timer.getMicroTime(),
		tempo_pisca=love.timer.getMicroTime(),
		exibe_pisca=true,
		mundo_escorrega=0,
		millsecs=0.10
	}
	if valor==1 then
		self[#self].tipo="coin_bronze"
	elseif valor==2 then
		self[#self].tipo="coin_silver"
	elseif valor==3 then
		self[#self].tipo="coin_gold"
	end
	self[#self].img=love.graphics.newImage("gfx/"..self[#moeda].tipo..".png")
	self[#self].vel_x=vx
	self[#self].vel_y=-vy
end

function moeda:draw()
	love.graphics.setColor(255,255,255,255)
	if exibe_mapa then love.graphics.setColor(100,100,100,100) end
	for i=1,#moeda,1 do
		mo=moeda[i]
		if mo~=nil then
			if mo.exibe_pisca==true then
				if mo.exibe then love.graphics.draw(mo.img,mo.x,mo.y) end
			end
			if exibe_mapa==false then
				if love.timer.getMicroTime()>=mo.tempo+4 then
					if love.timer.getMicroTime()>=mo.tempo_pisca+mo.millsecs then
						mo.tempo_pisca=love.timer.getMicroTime()
						mo.exibe_pisca=not mo.exibe_pisca
					end
					mo.millsecs=mo.millsecs-0.00025
				end
				if love.timer.getMicroTime()>=mo.tempo+6 then
					mo.exibe=false
				end
			end
		end
	end
	self:testa_colisao_jogador()
end

function moeda:testa_colisao_mundo()
	if #moeda>0 then
		for j=1,#moeda,1 do
			if moeda[j]~=nil then
				mo=moeda[j]
				mo.colisao=false
				mo.vel_y=mo.vel_y+gravidade
				mundo:testa_colisao_moeda(j)
				if mo.colisao==false then
					mo.x=mo.x+mo.vel_x
					mo.y=mo.y+mo.vel_y
					if mo.y>res_y then
						moeda[j].exibe=false
					end
				else
					mo.vel_x=0
					mo.vel_y=0
				end
			end
		end
	end
end

function moeda:testa_colisao_jogador()
	local jx,jy,jl,ja=jogador.x,jogador.y,img_jogador[jogador.frame]:getWidth(),img_jogador[jogador.frame]:getHeight()
	for i=1,#moeda,1 do
		if moeda[i]~=nil then
			mo=moeda[i]
			if mo.exibe==true then
				mox,moy,mol,moa=mo.x,mo.y,mo.img:getWidth(),mo.img:getHeight()
				if checa_colisao(jx,jy,jl,ja,mox,moy,mol,moa) then
					if mo.tipo=="coin_bronze" then
						jogador.moeda_bronze=jogador.moeda_bronze+1
					elseif mo.tipo=="coin_silver" then
						jogador.moeda_prata=jogador.moeda_prata+1
					elseif mo.tipo=="coin_gold" then
						jogador.moeda_ouro=jogador.moeda_ouro+1
					end
					for j=1,3 do
						efeito:add(mox,moy,"estrela")
					end
					mo.exibe=false
				end
			end
		end
	end
end

function moeda:atualiza_posicao_x()
	for i=1,#moeda,1 do
		if moeda[i]~=nil then
			mo=moeda[i]
			if string.find(jogador.direcao,"right")~=nil then
				mo.x=mo.x-val_x_atualiza_mundo
			elseif string.find(jogador.direcao,"left")~=nil then
				mo.x=mo.x+val_x_atualiza_mundo
			end
		end
	end
end

function moeda:libera_moeda()
	for j=1,jogador.moeda_ouro do
		dir=math.random(-1,1)
		if dir==0 then dir=1 end
		py=jogador.y+10
		px=jogador.x-40
		if dir==1 then px=jogador.x+img_jogador[jogador.frame]:getWidth()+40 end
		vx=math.random(1,4)*dir
		vy=math.random(2,5)
		moeda:add(px,py,3,vx,vy,dir)
		jogador.moeda_ouro=jogador.moeda_ouro-1
	end
	for j=1,jogador.moeda_prata do
		dir=math.random(-1,1)
		if dir==0 then dir=1 end
		py=jogador.y+10
		px=jogador.x-40
		if dir==1 then px=jogador.x+img_jogador[jogador.frame]:getWidth()+40 end
		vx=math.random(1,4)*dir
		vy=math.random(2,5)
		moeda:add(px,py,2,vx,vy,dir)
		jogador.moeda_prata=jogador.moeda_prata-1
	end
	for j=1,jogador.moeda_bronze do
		dir=math.random(-1,1)
		if dir==0 then dir=1 end
		py=jogador.y+10
		px=jogador.x-40
		if dir==1 then px=jogador.x+img_jogador[jogador.frame]:getWidth()+40 end
		vx=math.random(1,4)*dir
		vy=math.random(2,5)
		moeda:add(px,py,1,vx,vy,dir)
		jogador.moeda_bronze=jogador.moeda_bronze-1
	end
end

function moeda:apaga()
	for i=1,#moeda do
		moeda[i]=nil
	end
end
